﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="wallet_charge.aspx.cs" Inherits="VA.Modules.JDingMember.charge.member_charge" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>会员充值</title>
    <!--#include virtual="/modules/member/include/css/edit.aspx"-->
    <!--#include virtual="/modules/member/include/js/edit.aspx"-->     
    <script type="text/javascript">
        function confirm() {

            //调用asp.net验证控件自带的js数据验证脚本对控件进行验证；
            var validationResult = Page_ClientValidate('');
            if (!validationResult) {
                return;
            }

            var chargeDate = $("#spanChargeDate").html();
            var operatorName = $("#spanOperatorName").html();
            var payAmount = $("#txtPayAmount").val();
            var donateAmount = $("#txtDonateAmount").val();
            var chargeAmount = $("#txtChargeAmount").val();
            var payTypeName = $("#ddlPayTypes").find("option:selected").text();

            if (parseFloat(payAmount) < 0) {
                JTongAlert("提示", "充值金额不能为负数！", "error", function () {
                    $("#txtPayAmount").select();
                });
                return;
            }
            if (parseFloat(donateAmount) < 0) {
                JTongAlert("提示", "赠送金额不能为负数！", "error", function () {
                    $("#txtDonateAmount").select();
                });
                return;
            }

            $("#span_Confirm_ChargeDate").html(chargeDate);
            $("#span_Confirm_OperatorName").html(operatorName);
            $("#span_Confirm_PayAmount").html(parseFloat(payAmount).toFixed(2).toString());
            $("#span_Confirm_DonateAmount").html(parseFloat(donateAmount).toFixed(2).toString());
            $("#span_Confirm_ChargeAmount").html(parseFloat(chargeAmount).toFixed(2).toString());
            $("#span_Confirm_PayTypeName").html(payTypeName);

            $('#winConfirm').css("display", "block");
            $('#winConfirm').window({
                width: 350,
                height: 368,
                left: 180,
                top:116,
                modal: true,
                maximizable: false,
                minimizable: false,
                collapsible: false,
                title: '确认'
            });
            $("#btnSubmit").focus();
        }

        function cancelSave() {
            $('#winConfirm').window("close");
        }

        function save() {

            $("#btnSubmit").attr("disabled", "disabled");

            var requestType = "POST";
            var url = pageName + "?act=add";  //pageName在BasePage中注册到的客户端；
            var dataType = "html";
            var data = $("form").eq(0).serialize();
            var successFN = function (data, textStatus) {
                var bizNo = "";
                if (data.substring(0, 2) == "ok") {
                    bizNo = data.split("|")[1];
                    showActResult("充值成功！", true, doAfterAdd, bizNo);
                } else if (data.indexOf("01|") != -1) {
                    showActResult(data.substring(3), false, doAfterAdd, bizNo);
                }
                else {
                    showActResult("充值失败：" + data, false, doAfterAdd, bizNo);
                }                
            };
            ajaxRequest(requestType,
                url,
                dataType,
                data,
                successFN,
                errorFN
                );            
        }

        function doAfterAdd(actResult, bizNo) {
            if (actResult) {
                if ($("#ckbPrintBill")[0].checked == true) {
                    printBill("1", bizNo);
                }

                if ($("#ckbNotify")[0].checked == true) {
                    ajaxExecute("get", "../notification/biztransaction_notify.aspx", { "biztype": "walletcharge", "bizno": bizNo });
                }                

                cancelSave();
                resetPage();
            }
        }

        //显示操作结果；
        function showActResult(sMsg, actResult, callback, bizNo) {

            $("#btnSubmit").removeAttr("disabled");
                       
            var icon = "info";
            if (!actResult) {
                icon = "error";
            }

            JTongAlert('操作结果', sMsg, icon, function () {
                if (callback != null && callback != undefined) {
                    callback(actResult, bizNo);
                }
            });
        }

        function resetPage() {
            
            clearMemberInfo();

            $("#txtPayAmount").val("");
            $("#txtDonateAmount").val("0.00");
            $("#txtChargeAmount").val("");
            //$("#ddlPayTypes")[0].options[0].selected = true;
            $("#txtRemark").val("");

            $("#txtPayAmount").attr("disabled", "disabled");
            $("#txtDonateAmount").attr("disabled", "disabled");
            $("#txtChargeAmount").attr("disabled", "disabled");
            $("#ddlPayTypes").attr("disabled", "disabled");
            $("#txtRemark").attr("disabled", "disabled");
            $("#btnNext").attr("disabled", "disabled");  

            clearInputValidatorError();
        }

        //会员信息加载成功时调用的方法；            
        function doWhenMemberInfoLoadSuc(memberInfo) {
            $("#txtPayAmount").removeAttr("disabled");
            $("#txtDonateAmount").removeAttr("disabled");
            $("#ddlPayTypes").removeAttr("disabled");
            $("#txtRemark").removeAttr("disabled");
            //$("#btnNext").removeAttr("disabled");  //更改为输入充值金额并敲击回车后，再启用按钮，以防未来的及应用优惠策略便执行充值。

            $("#txtPayAmount").focus();
        }

        //会员信息加载失败时调用的方法；
        function doWhenMemberInfoLoadFail() {

        }

        function caculateChargeAmount() {
            var sPayAmount = $.trim($("#txtPayAmount").val());
            var sDonateAmount = $.trim($("#txtDonateAmount").val());
            var chargeAmount = 0.00;
            if (sPayAmount != "") {

                if (sDonateAmount == "") {
                    sDonateAmount = "0.00";
                }

                chargeAmount = parseFloat(sPayAmount) + parseFloat(sDonateAmount);
                $("#txtChargeAmount").val(chargeAmount);
            }
        }

        function applySaleStrategy() {

            var chargeAmount = $("#txtPayAmount").val();
            if ($.trim(chargeAmount) == "") {
                return;
            }

            var validator = new DataValidator();
            if (!validator.isFloat(chargeAmount)) {
                JTongAlert("提示", "\"充值金额\"不是有效的数字！", "error", function () {
                    $("#txtPayAmount").select();                    
                });                
                return;
            }

            $.ajax({
                type: "GET",
                url: "apply_charge_salestategy.aspx",
                dataType: "html",
                async: false,
                data: { "memberID": $("#hfMemberID").val(), "chargeAmount": chargeAmount },
                success: function (data, textStatus) {
                    if (data != "error") {
                        if (data == "") {
                            caculateChargeAmount();
                        } else {
                            var ssResult = JSON.parse(data);
                            $("#txtDonateAmount").val(ssResult.donateAmount);
                            $("#hfStrategyCode").val(ssResult.strategyCode);
                            $("#hfStrategyName").val(ssResult.strategyName);
                            caculateChargeAmount();
                        }
                    }
                    else {
                        showActResult("应用营销策略失败！", false);
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    showActResult("请求失败！textStatus :" + textStatus, false);
                }
            });
        }

        $(function () {

            $("#txtPayAmount").keyup(function (event) {
                caculateChargeAmount();                
            }).keydown(function () {
                if (event.keyCode == 13) {
                    applySaleStrategy();
                    $("#btnNext").removeAttr("disabled");
                }
            });

            $("#txtDonateAmount").keyup(function (event) {
                caculateChargeAmount();
            });

            $("#txtPayAmount").attr("disabled", "disabled");
            $("#txtDonateAmount").attr("disabled", "disabled");
            $("#txtChargeAmount").attr("disabled", "disabled");
            $("#ddlPayTypes").attr("disabled", "disabled");
            $("#txtRemark").attr("disabled", "disabled");
            $("#btnNext").attr("disabled", "disabled");
            $("#txtChargeAmount").attr("disabled", "disabled");

            //焦点控制；
            $("input,select").keydown(function (event) {
                if (event.keyCode == 13) {
                    var targetID = event.target.id;
                    switch (targetID) {
                        case "txtPayAmount":
                            if ($("#txtPayAmount").val() != "") {
                                $("#txtDonateAmount").select();
                            }
                            break;
                        case "txtDonateAmount":
                            $("#ddlPayTypes").focus();
                            break;
                        case "ddlPayTypes":
                            $("#txtRemark").focus();
                            break;
                        case "txtRemark":
                            confirm();
                            return false;
                            break;
                        default:
                            break;
                    }
                }
            });
        });

    </script>

</head>
<body>
<form id="Form1" method="post" runat="server">

<div id="noteBar">                          
    <p>注：客户机需要安装客户端助手才能实现充值、消费等业务的小票打印及实体会员卡的读取。</p>
</div><!--noteBar.END--> 

<div class="editPageWrapper" style="width:700px;">

<div class="centerFormTitle">
   <h1>会员充值</h1>
</div>

<!--#include file="../include/memberinfo.aspx"--> 

<table cellspacing="0" cellpadding="3" class="editTable" style="margin-top:-1px;">
<tr>
<td class="th" colspan="2" style="font-weight:bold;text-align:left;">充值信息</td>
</tr>
<tr>
<td class="th">充值日期：</td>
<td>    
	<span id="spanChargeDate"><% = DateTime.Now.ToString("yyyy-MM-dd") %></span>
</td>
</tr>
<tr>
<td class="th">操作员：</td>
<td>    
	<span id="spanOperatorName"><% = base.EmployeeName %></span>
</td>
</tr>
<tr>
<td class="th">(<span class="note mustfill">*</span>)充值金额：</td>
<td>
    <VACTL:TextBox runat="server" ID="txtPayAmount" 
            CssClass="input" 
            Width="100px"
            CanBeNull="No"
            FieldName="充值金额"
            RequiredFieldType="Money"
            />
    <asp:HiddenField runat="server" id="hfStrategyCode" />
    <asp:HiddenField runat="server" id="hfStrategyName" />
    <span class="note">注：输入充值金额后，回车。</span>
</td>
</tr>
<tr>
<td class="th">(<span class="note mustfill">*</span>)赠送金额：</td>
<td>
    <VACTL:TextBox runat="server" ID="txtDonateAmount" 
            CssClass="input" 
            Width="100px"
            CanBeNull="No"
            FieldName="赠送金额"
            RequiredFieldType="Money"
            Text="0.00"
            />
</td>
</tr>
<tr>
<td class="th">(<span class="note mustfill">*</span>)充值合计：</td>
<td>
    <VACTL:TextBox runat="server" ID="txtChargeAmount" 
            CssClass="input" 
            Width="100px"
            CanBeNull="No"
            Enabled="false"
            FieldName="充值合计"
            />
</td>
</tr>
<tr>
<td class="th">(<span class="note mustfill">*</span>)付款方式：</td>
<td>
    <asp:DropDownList ID="ddlPayTypes" Runat="server" >
    </asp:DropDownList>
</td>
</tr>
<tr>
<td class="th">备注：</td>
<td>    
	<VACTL:TextBox ID="txtRemark" Runat="server"
		 EnableViewState="False"
		 CssClass="input"
         Width="200px"
         MaxLength="100"  />	
</td>
</tr>

<tr>
<td colspan="2" class="footer">

    <input type="button" id="btnNext" class="btn" style="width:80px" onclick="confirm()" value="充值" />
    <input type="button" id="btnResetPage" class="btn" style="width:80px" onclick="resetPage()" value="重置" />
    <asp:HiddenField ID="hfKey" runat="server" />
    
    <VACTL:Hint ID="Hint1" runat="server" HintImageUrl="/admin/app_themes/default/images/control" />
    <VACTL:ValidationSummary ID="ValidationSummary1" runat="server"
            DisplayMode="List"
            EnableClientScript="true" />
    
    <!--注意：这个文件一定要放到页面底部，以便覆盖asp.net验证脚本中的同名函数-->
    <script type="text/javascript" src="/scripts/utils/aspnet_validator_extend.js"></script>
</td>
</tr>
</table>

<!--每个页面上只能有一个该控件实例-->
<VACTL:SmartDropDownList ID="SmartDropDownList1" runat="server"></VACTL:SmartDropDownList>  

</div><!--editPageWrapper.END-->

<!--确认窗口-->    
<div id="winConfirm" style="display:none;">

    <div style="width:300px;margin:auto;">
    
    <br />

    <div class="centerFormTitle">
        <h1>确认充值信息</h1>
    </div>

    <table cellspacing="0" cellpadding="3" class="editTable" style="margin:auto;width:300px;">
    <tr>
    <td class="th">操 作 员：</td>
    <td>    
	    <span id="span_Confirm_OperatorName"></span>
    </td>
    </tr>
    <tr>
    <td class="th">充值日期：</td>
    <td>    
	    <span id="span_Confirm_ChargeDate"></span>
    </td>
    </tr>
    <tr>
    <td class="th">充值金额：</td>
    <td>    
	    <span id="span_Confirm_PayAmount" style="font-weight:bold;"></span>
    </td>
    </tr>
    <tr>
    <td class="th">赠送金额：</td>
    <td>    
        <span id="span_Confirm_DonateAmount" style="font-weight:bold;"></span>
    </td>
    </tr>
    <tr>
    <td class="th">充值合计：</td>
    <td>   
        <span id="span_Confirm_ChargeAmount" style="font-weight:bold;"></span> 
    </td>
    </tr>
    <tr>
    <td class="th">支付方式：</td>
    <td>    
        <span id="span_Confirm_PayTypeName" style="font-weight:bold;"></span>
    </td>
    </tr>
    <tr>
    <td colspan="2" style="text-align:center;">    
        <asp:CheckBox ID="ckbPrintBill" runat="server"
             Text="打票" />         
        <asp:CheckBox ID="ckbNotify" runat="server"
             Text="短信通知" />         
    </td>
    </tr>
    <tr>
    <td colspan="2" class="footer">

        <input type="button" id="btnSubmit" class="btn" style="width:80px" onclick="save(0)" value="确定" />
        <input type="button" id="btnCancel" class="btn" style="width:80px" onclick="cancelSave()" value="取消" />        

    </td>
    </tr>
    </table>
    </div>

</div><!--winConfirm.END-->

</form>
</body>
</html>

