/*******************************************************************************
//  Ȩ  (C) 2015 ̿
//    MCItem.cs
//  ļ˵ޣ
//      
//
//  ʶ־ 2016-01-07 10:56:18
//
//  ޸ıʶ
//  ޸˵
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.Data;

using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Model;

namespace VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Business
{
    /// <summary>
    /// Աϸ¼ҵࣻ
    /// </summary>
    public class MCItem
    {
        const string CODE_PATH = "Core.MCItem.";
        DataAccess.MCItem mCItemObj = null;

        public MCItem()
        {
            mCItemObj = new DataAccess.MCItem();
        }

        #region Add 
        /// <summary>
        /// ӣ
        /// </summary>
        /// <param name="entity">Աϸ¼ʵ</param>
        /// <param name="errorMsg">ʧܵԭ򣨽ʧʱЧ</param>
        /// <param name="args">չҵӰ죩</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool Add(MCItemInfo entity, out string errorMsg, params object[] args)
        {
            errorMsg = null;

            try
            {
                //ʼ
                using (TransactionWrapper transScope = new TransactionWrapper())
                {
                    try
                    {
                        transScope.BeginTrans(); //ʼ

                        if (!this.mCItemObj.Insert(entity, transScope.Transaction))
                        {
                            throw new Exception("ʧܣ");
                        }

                        transScope.Complete();
                        return true;
                    }
                    catch (Exception ex)
                    {
                        transScope.Rollback(); //쳣ػع
                        throw; //׳쳣
                    }
                    finally
                    {
                        transScope.Dispose(); //
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.Add(...):" + ex.Message);
            }
        }
        #endregion

        #region AddBatchlly 
        /// <summary>
        /// ӣ
        /// </summary>
        /// <param name="entity">Աϸ¼ʵ</param>
        /// <param name="errorMsg">ʧܵԭ򣨽ʧʱЧ</param>
        /// <param name="args">չҵӰ죩</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool AddBatchlly(List<MCItemInfo> itemList, out string errorMsg, params object[] args)
        {
            errorMsg = null;

            try
            {
                //ʼ
                using (TransactionWrapper transScope = new TransactionWrapper())
                {
                    try
                    {
                        transScope.BeginTrans(); //ʼ

                        foreach (MCItemInfo item in itemList)
                        {
                            if (!this.mCItemObj.Insert(item, transScope.Transaction))
                            {
                                throw new Exception("ʧܣ");
                            } 
                        }
                        
                        transScope.Complete();
                        return true;
                    }
                    catch (Exception ex)
                    {
                        transScope.Rollback(); //쳣ػع
                        throw; //׳쳣
                    }
                    finally
                    {
                        transScope.Dispose(); //
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.AddBatchlly(...):" + ex.Message);
            }
        }
        #endregion

        #region DeleteByBizNo ɾ
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <param name="errorMsg">ɾʧܵԭ򣨽ɾʧʱЧ</param>
        /// <param name="args">չҵӰ죩</param>
        /// <returns>ɾɹ򷵻ػԱϸ¼룬򣬷ؿַ</returns>
        public bool DeleteByBizNo(string bizNo, out string errorMsg, params object[] args)
        {
            errorMsg = null;

            try
            {
                return mCItemObj.DeleteByBizNo(bizNo);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.DeleteByBizNo(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataList õݼ
        /// <summary>
        /// õݼ
        /// </summary>		
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݡ磺"ID DESC"</param>
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(string sqlFilter, string orderBy)
        {
            try
            {
                return mCItemObj.GetDataList(sqlFilter, orderBy);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õݼ
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">磺SaleState ASC,CarID DESC</param>        
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            try
            {
                return mCItemObj.GetDataList(currPage, pageSize, sqlFilter, orderBy);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataList(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataListCnt
        /// <summary>
        /// õ¼
        /// </summary>
        /// <param name="sqlCondition">ѯ(WHERE)</param>
        /// <returns>int</returns>
        public int GetDataListCnt(string sqlFilter)
        {
            try
            {
                return mCItemObj.GetDataListCnt(sqlFilter);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataListCnt(...):" + ex.Message);
            }
        }
        #endregion

        #region GetList õԱϸ¼ʵ弯
        /// <summary>
        /// õԱϸ¼ʵ弯
        /// </summary>
        /// <param name="sqlCondition">ѯ</param>
        /// <param name="orderBy">ݣ磺ORDER BY ID DESC</param>
        /// <returns>Աϸ¼ʵ弯</returns>
        public List<MCItemInfo> GetList(string sqlCondition, string orderBy)
        {
            try
            {
                DataTable dtb = mCItemObj.GetDataList(sqlCondition, orderBy);
                List<MCItemInfo> mCItemEntities = ConvertDataTableToEntityList(dtb);

                return mCItemEntities;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õԱϸ¼ʵ弯
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݣ磺"ID DESC"</param>
        /// <returns>Աϸ¼ʵ弯</returns>
        public List<MCItemInfo> GetList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            try
            {
                DataTable dtb = mCItemObj.GetDataList(currPage, pageSize, sqlFilter, orderBy);
                List<MCItemInfo> mCItemEntities = ConvertDataTableToEntityList(dtb);

                return mCItemEntities;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetList(...):" + ex.Message);
            }
        }
        #endregion

        #region ConvertDataTableToEntityList DataTableתΪMCItemInfo
        /// <summary>
        /// DataTableתΪArticleEntity
        /// </summary>
        /// <param name="dtb"></param>
        /// <returns></returns>
        List<MCItemInfo> ConvertDataTableToEntityList(DataTable dtb)
        {
            List<MCItemInfo> mCItemEntities = new List<MCItemInfo>();

            MCItemInfo mCItemInfo = null;

            for (int i = 0; i < dtb.Rows.Count; i++)
            {
                mCItemInfo = new MCItemInfo();

                DataRow row = dtb.Rows[i];

                if (row["RID"] != DBNull.Value)
                {
                    mCItemInfo.RID = Convert.ToInt32(row["RID"]);
                }

                if (row["BizNo"] != DBNull.Value)
                {
                    mCItemInfo.BizNo = row["BizNo"].ToString();
                }

                if (row["Item_Type"] != DBNull.Value)
                {
                    mCItemInfo.Item_Type = row["Item_Type"].ToString();
                }

                if (row["Item_Code"] != DBNull.Value)
                {
                    mCItemInfo.Item_Code = row["Item_Code"].ToString();
                }

                if (row["Item_Name"] != DBNull.Value)
                {
                    mCItemInfo.Item_Name = row["Item_Name"].ToString();
                }

                if (row["Unit"] != DBNull.Value)
                {
                    mCItemInfo.Unit = row["Unit"].ToString();
                }

                if (row["Price"] != DBNull.Value)
                {
                    mCItemInfo.Price = Convert.ToDecimal(row["Price"]);
                }

                if (row["Quantity"] != DBNull.Value)
                {
                    mCItemInfo.Quantity = Convert.ToDecimal(row["Quantity"]);
                }

                if (row["Costs"] != DBNull.Value)
                {
                    mCItemInfo.Costs = Convert.ToDecimal(row["Costs"]);
                }

                if (row["Charges"] != DBNull.Value)
                {
                    mCItemInfo.Charges = Convert.ToDecimal(row["Charges"]);
                }

                if (row["Discounts"] != DBNull.Value)
                {
                    mCItemInfo.Discounts = Convert.ToDecimal(row["Discounts"]);
                }

                if (row["Discount_Desc"] != DBNull.Value)
                {
                    mCItemInfo.Discount_Desc = row["Discount_Desc"].ToString();
                }

                if (row["Waiter_Code"] != DBNull.Value)
                {
                    mCItemInfo.Waiter_Code = row["Waiter_Code"].ToString();
                }

                if (row["Waiter_Name"] != DBNull.Value)
                {
                    mCItemInfo.Waiter_Name = row["Waiter_Name"].ToString();
                }

                if (row["Settle_Account_Flag"] != DBNull.Value)
                {
                    mCItemInfo.Settle_Account_Flag = row["Settle_Account_Flag"].ToString();
                }


                mCItemEntities.Add(mCItemInfo);
            }

            return mCItemEntities;
        }
        #endregion

    } //class end.
} //namespace end.

