/*******************************************************************************
//  Ȩ  (C) 2015 ̿
//    MCPayment.cs
//  ļ˵ޣ
//      
//
//  ʶ־ 2016-01-07 10:58:19
//
//  ޸ıʶ
//  ޸˵
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.Data;

using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Model;

namespace VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Business
{
    /// <summary>
    /// Ա֧ʽ¼ҵࣻ
    /// </summary>
    public class MCPayment
    {
        const string CODE_PATH = "Core.MCPayment.";
        DataAccess.MCPayment mCPaymentObj = null;

        public MCPayment()
        {
            mCPaymentObj = new DataAccess.MCPayment();
        }

        #region AddBatchlly 
        /// <summary>
        /// ӣ
        /// </summary>
        /// <param name="entity">Ա֧ʽ¼ʵ</param>
        /// <param name="errorMsg">ʧܵԭ򣨽ʧʱЧ</param>
        /// <param name="args">չҵӰ죩</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool AddBatchlly(List<MCPaymentInfo> paymentList, out string errorMsg, params object[] args)
        {
            errorMsg = null;

            try
            {
                //ʼ
                using (TransactionWrapper transScope = new TransactionWrapper())
                {
                    try
                    {
                        transScope.BeginTrans(); //ʼ

                        foreach (MCPaymentInfo item in paymentList)
                        {
                            if (!this.mCPaymentObj.Insert(item, transScope.Transaction))
                            {
                                throw new Exception("ʧܣ");
                            }
                        }

                        transScope.Complete();
                        return true;
                    }
                    catch (Exception ex)
                    {
                        transScope.Rollback(); //쳣ػع
                        throw; //׳쳣
                    }
                    finally
                    {
                        transScope.Dispose(); //
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.AddBatchlly(...):" + ex.Message);
            }
        }
        #endregion

        #region DeleteByBizNo ɾ
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <param name="errorMsg">ɾʧܵԭ򣨽ɾʧʱЧ</param>
        /// <param name="args">չҵӰ죩</param>
        /// <returns>ɾɹ򷵻ػԱ֧ʽ¼룬򣬷ؿַ</returns>
        public bool DeleteByBizNo(string bizNo, out string errorMsg, params object[] args)
        {
            errorMsg = null;

            try
            {
                return mCPaymentObj.DeleteByBizNo(bizNo);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.DeleteByBizNo(...):" + ex.Message);
            }
        }
        #endregion
      
        #region GetDataList õݼ
        /// <summary>
        /// õݼ
        /// </summary>		
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݡ磺"ID DESC"</param>
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(string sqlFilter, string orderBy)
        {
            try
            {
                return mCPaymentObj.GetDataList(sqlFilter, orderBy);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õݼ
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">磺SaleState ASC,CarID DESC</param>        
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            try
            {
                return mCPaymentObj.GetDataList(currPage, pageSize, sqlFilter, orderBy);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataList(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataListCnt
        /// <summary>
        /// õ¼
        /// </summary>
        /// <param name="sqlCondition">ѯ(WHERE)</param>
        /// <returns>int</returns>
        public int GetDataListCnt(string sqlFilter)
        {
            try
            {
                return mCPaymentObj.GetDataListCnt(sqlFilter);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataListCnt(...):" + ex.Message);
            }
        }
        #endregion

        #region GetList õԱ֧ʽ¼ʵ弯
        /// <summary>
        /// õԱ֧ʽ¼ʵ弯
        /// </summary>
        /// <param name="sqlCondition">ѯ</param>
        /// <param name="orderBy">ݣ磺ORDER BY ID DESC</param>
        /// <returns>Ա֧ʽ¼ʵ弯</returns>
        public List<MCPaymentInfo> GetList(string sqlCondition, string orderBy)
        {
            try
            {
                DataTable dtb = mCPaymentObj.GetDataList(sqlCondition, orderBy);
                List<MCPaymentInfo> mCPaymentEntities = ConvertDataTableToEntityList(dtb);

                return mCPaymentEntities;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õԱ֧ʽ¼ʵ弯
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݣ磺"ID DESC"</param>
        /// <returns>Ա֧ʽ¼ʵ弯</returns>
        public List<MCPaymentInfo> GetList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            try
            {
                DataTable dtb = mCPaymentObj.GetDataList(currPage, pageSize, sqlFilter, orderBy);
                List<MCPaymentInfo> mCPaymentEntities = ConvertDataTableToEntityList(dtb);

                return mCPaymentEntities;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetList(...):" + ex.Message);
            }
        }
        #endregion

        #region ConvertDataTableToEntityList DataTableתΪMCPaymentInfo
        /// <summary>
        /// DataTableתΪArticleEntity
        /// </summary>
        /// <param name="dtb"></param>
        /// <returns></returns>
        List<MCPaymentInfo> ConvertDataTableToEntityList(DataTable dtb)
        {
            List<MCPaymentInfo> mCPaymentEntities = new List<MCPaymentInfo>();

            MCPaymentInfo mCPaymentInfo = null;

            for (int i = 0; i < dtb.Rows.Count; i++)
            {
                mCPaymentInfo = new MCPaymentInfo();

                DataRow row = dtb.Rows[i];

                if (row["RID"] != DBNull.Value)
                {
                    mCPaymentInfo.RID = Convert.ToInt32(row["RID"]);
                }

                if (row["BizNo"] != DBNull.Value)
                {
                    mCPaymentInfo.BizNo = row["BizNo"].ToString();
                }

                if (row["PayType_Code"] != DBNull.Value)
                {
                    mCPaymentInfo.PayType_Code = row["PayType_Code"].ToString();
                }

                if (row["PayType_Name"] != DBNull.Value)
                {
                    mCPaymentInfo.PayType_Name = row["PayType_Name"].ToString();
                }

                if (row["PayAmount"] != DBNull.Value)
                {
                    mCPaymentInfo.PayAmount = Convert.ToDecimal(row["PayAmount"]);
                }

                if (row["Certificate_No"] != DBNull.Value)
                {
                    mCPaymentInfo.Certificate_No = row["Certificate_No"].ToString();
                }


                mCPaymentEntities.Add(mCPaymentInfo);
            }

            return mCPaymentEntities;
        }
        #endregion

    } //class end.
} //namespace end.

