/*******************************************************************************
//  Ȩ  (C) 2015 ̿
//    MCItem.cs
//  ļ˵Աϸ¼ݲࣻ
//      
//
//  ʶ־ 2016-01-07 10:39:51
//
//  ޸ıʶ
//  ޸˵
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

using VA.Utils;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Config;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Model;

namespace VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.DataAccess
{
    /// <summary>
    /// Աϸ¼ݲࣻ
    /// </summary>
    public class MCItem : DAOBase
    {
        const string CODE_PATH = "DAL.MCItem.";
        SqlParameter[] parms = null;

        static string Tb_Prefix = DBConfig.Tb_Prefix;
        string SQL_INSERT = "INSERT INTO va_Interface_MC_Items(BizNo,Item_Type,Item_Category,Item_Code,Item_Name,Unit,Price,Quantity,Costs,Charges,Discounts,Discount_Desc,Waiter_Code,Waiter_Name,Settle_Account_Flag)VALUES(@BizNo,@Item_Type,@Item_Category,@Item_Code,@Item_Name,@Unit,@Price,@Quantity,@Costs,@Charges,@Discounts,@Discount_Desc,@Waiter_Code,@Waiter_Name,@Settle_Account_Flag)";
        string SQL_DELETE_BY_BIZNO = "DELETE FROM va_Interface_MC_Items WHERE BizNo=@BizNo";
        string SQL_GETLIST = "SELECT * FROM va_Interface_MC_Items";
        string SQL_GETLIST_CNT = "SELECT COUNT(*) FROM va_Interface_MC_Items";
        string PRO_GETLIST = "va_Pager201301";

        #region Insert 
        /// <summary>
        /// 룻
        /// </summary>
        /// <param name="entity">Աϸ¼ʵ</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool Insert(MCItemInfo entity,SqlTransaction trans)
        {
            try
            {
                parms = GetParameters(entity);
                int affectedRows = SQLHelper.ExecuteNonQuery(trans, CommandType.Text, SQL_INSERT, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.Insert(...):" + ex.Message);
            }
        }
        #endregion

        #region Delete ɾ
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns>ɾɹ򷵻true򣬷false</returns>
        public bool DeleteByBizNo(string bizNo)
        {
            try
            {
                SqlParameter[] parms = new SqlParameter[]
				{
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, bizNo)
				};
                int affectedRows = SQLHelper.ExecuteNonQuery(DBConfig.ConnectionString, CommandType.Text, SQL_DELETE_BY_BIZNO, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.DeleteByBizNo(...):" + ex.Message);
            }
        }
        #endregion        

        #region GetDataList õݼ
        /// <summary>
        /// õݼ
        /// </summary>		
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݡ磺"ID DESC"</param>
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            string cmdText = SQL_GETLIST;

            if (!String.IsNullOrEmpty(sqlFilter))
            {
                cmdText += " WHERE 1=1 AND " + sqlFilter;
            }

            if (!String.IsNullOrEmpty(orderBy))
            {
                cmdText += " ORDER BY " + orderBy;
            }

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(DBConfig.ConnectionString, CommandType.Text, cmdText, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õݼ
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">磺SaleState ASC,CarID DESC</param>        
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            SqlParameter[] parms = new SqlParameter[]
            {
                SQLHelper.MakeInParam("@TableName", SqlDbType.VarChar, "va_Interface_MC_Items"),
                SQLHelper.MakeInParam("@SqlFilter", SqlDbType.VarChar, sqlFilter),                    
                SQLHelper.MakeInParam("@KeyFieldName", SqlDbType.VarChar, "RID"),                    
                SQLHelper.MakeInParam("@OrderBy", SqlDbType.VarChar, orderBy),
                SQLHelper.MakeInParam("@PageIndex", SqlDbType.Int, currPage),                      
                SQLHelper.MakeInParam("@PageSize", SqlDbType.Int, pageSize)       
            };

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(base.ConnectionString, CommandType.StoredProcedure, PRO_GETLIST, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataList(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataListCnt
        /// <summary>
        /// õ¼
        /// </summary>
        /// <param name="sqlCondition">ѯ(WHERE)</param>
        /// <returns>int</returns>
        public int GetDataListCnt(string sqlFilter)
        {
            try
            {
                sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
                string tmpSqlFilter = sqlFilter.ToUpper().Trim();
                if (tmpSqlFilter.StartsWith("WHERE"))
                {
                    throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
                }
                if (tmpSqlFilter.StartsWith("AND"))
                {
                    throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
                }

                if (!String.IsNullOrEmpty(sqlFilter))
                {
                    sqlFilter = "WHERE " + sqlFilter;
                }

                string cmdText = SQL_GETLIST_CNT + " " + sqlFilter;
                return (int)SQLHelper.ExecuteScalar(base.ConnectionString, CommandType.Text, cmdText);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCItem.GetDataListCnt(...):" + ex.Message);
            }
        }
        #endregion

        #region GetParametersGetKeyParameter ȡ
        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name=" entity">ʵ</param>
        /// <returns>SqlParameter</returns>
        SqlParameter[] GetParameters(MCItemInfo entity)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, entity.RID),
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, entity.BizNo),
					SQLHelper.MakeInParam("@Item_Type", SqlDbType.VarChar, entity.Item_Type),
                    SQLHelper.MakeInParam("@Item_Categroy", SqlDbType.VarChar, entity.Item_Category),
					SQLHelper.MakeInParam("@Item_Code", SqlDbType.VarChar, entity.Item_Code),
					SQLHelper.MakeInParam("@Item_Name", SqlDbType.VarChar, entity.Item_Name),
					SQLHelper.MakeInParam("@Unit", SqlDbType.VarChar, entity.Unit),
					SQLHelper.MakeInParam("@Price", SqlDbType.Decimal, entity.Price),
					SQLHelper.MakeInParam("@Quantity", SqlDbType.Decimal, entity.Quantity),
					SQLHelper.MakeInParam("@Costs", SqlDbType.Decimal, entity.Costs),
					SQLHelper.MakeInParam("@Charges", SqlDbType.Decimal, entity.Charges),
					SQLHelper.MakeInParam("@Discounts", SqlDbType.Decimal, entity.Discounts),
					SQLHelper.MakeInParam("@Discount_Desc", SqlDbType.VarChar, entity.Discount_Desc),
					SQLHelper.MakeInParam("@Waiter_Code", SqlDbType.VarChar, entity.Waiter_Code),
					SQLHelper.MakeInParam("@Waiter_Name", SqlDbType.VarChar, entity.Waiter_Name),
					SQLHelper.MakeInParam("@Settle_Account_Flag", SqlDbType.VarChar, entity.Settle_Account_Flag)
				};
        }

        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns></returns>
        SqlParameter[] GetKeyParameter(int rID)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, rID)
				};
        }
        #endregion

    } //class end.
} //namespace end.

