/*******************************************************************************
//  Ȩ  (C) 2015 ̿
//    MCMaster.cs
//  ļ˵Ա¼ݲࣻ
//      
//
//  ʶ־ 2016-01-07 10:39:12
//
//  ޸ıʶ
//  ޸˵
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

using VA.Utils;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Config;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Model;

namespace VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.DataAccess
{
    /// <summary>
    /// Ա¼ݲࣻ
    /// </summary>
    public class MCMaster : DAOBase
    {
        const string CODE_PATH = "DAL.MCMaster.";
        SqlParameter[] parms = null;

        static string Tb_Prefix = DBConfig.Tb_Prefix;
        string SQL_INSERT = "INSERT INTO va_Interface_MC_Master(Shop_Code,BizNo,CardNo,MemberID,Name,Sex,MobileNo,Operate_Date,Operator_Code,Operator_Name,Costs,Charges,Discounts,PayAmount,Remark,DataFrom)VALUES(@Shop_Code,@BizNo,@CardNo,@MemberID,@Name,@Sex,@MobileNo,@Operate_Date,@Operator_Code,@Operator_Name,@Costs,@Charges,@Discounts,@PayAmount,@Remark,@DataFrom)";
        string SQL_DELETE_BY_BIZNO = "DELETE FROM va_Interface_MC_Master WHERE BizNo=@BizNo";
        string SQL_GETENTITY_BY_BIZNO = "SELECT * FROM va_Interface_MC_Master WHERE BizNo=@BizNo";
        string SQL_GETLIST = "SELECT * FROM va_Interface_MC_Master";
        string SQL_GETLIST_CNT = "SELECT COUNT(*) FROM va_Interface_MC_Master";
        string PRO_GETLIST = "va_Pager201301";

        #region Insert 
        /// <summary>
        /// 룻
        /// </summary>
        /// <param name="entity">Ա¼ʵ</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool Insert(MCMasterInfo entity)
        {
            try
            {
                parms = GetParameters(entity);
                int affectedRows = SQLHelper.ExecuteNonQuery(DBConfig.ConnectionString, CommandType.Text, SQL_INSERT, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.Insert(...):" + ex.Message);
            }
        }
        #endregion

        #region DeleteByBizNo ɾ
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns>ɾɹ򷵻true򣬷false</returns>
        public bool DeleteByBizNo(string bizNo)
        {
            try
            {
                SqlParameter[] parms = new SqlParameter[]
				{
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, bizNo)
				};
                int affectedRows = SQLHelper.ExecuteNonQuery(DBConfig.ConnectionString, CommandType.Text, SQL_DELETE_BY_BIZNO, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.DeleteByBizNo(...):" + ex.Message);
            }
        }
        #endregion

        #region GetEntity õԱ¼ʵ
        /// <summary>
        /// õԱ¼ʵ壻
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns>Ա¼ʵ</returns>
        public MCMasterInfo GetEntityByBizNo(string bizNo)
        {
            MCMasterInfo entity = new MCMasterInfo();

            try
            {
                SqlParameter[] parms = new SqlParameter[]
				{
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, bizNo)
				};
                SqlDataReader dr = SQLHelper.ExecuteReader(DBConfig.ConnectionString, CommandType.Text, SQL_GETENTITY_BY_BIZNO, parms);
                if (dr.Read())
                {
                    entity.RID = Convert.ToInt32(dr["RID"]);
                    entity.Shop_Code = dr["Shop_Code"].ToString();
                    entity.BizNo = dr["BizNo"].ToString();
                    entity.CardNo = dr["CardNo"].ToString();
                    entity.MemberID = dr["MemberID"].ToString();
                    entity.Name = dr["Name"].ToString();
                    entity.Sex = dr["Sex"].ToString();
                    entity.MobileNo = dr["MobileNo"].ToString();
                    entity.Operate_Date = Convert.ToDateTime(dr["Operate_Date"]);
                    entity.Operator_Code = dr["Operator_Code"].ToString();
                    entity.Operator_Name = dr["Operator_Name"].ToString();
                    entity.Costs = Convert.ToDecimal(dr["Costs"]);
                    entity.Charges = Convert.ToDecimal(dr["Charges"]);
                    entity.Discounts = Convert.ToDecimal(dr["Discounts"]);
                    entity.PayAmount = Convert.ToDecimal(dr["PayAmount"]);
                    entity.Remark = dr["Remark"].ToString();
                    entity.DataFrom = dr["DataFrom"].ToString();
                }
                dr.Close();

                return entity;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.GetEntityByBizNo(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataList õݼ
        /// <summary>
        /// õݼ
        /// </summary>		
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݡ磺"ID DESC"</param>
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            string cmdText = SQL_GETLIST;

            if (!String.IsNullOrEmpty(sqlFilter))
            {
                cmdText += " WHERE 1=1 AND " + sqlFilter;
            }

            if (!String.IsNullOrEmpty(orderBy))
            {
                cmdText += " ORDER BY " + orderBy;
            }

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(DBConfig.ConnectionString, CommandType.Text, cmdText, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.GetDataList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õݼ
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">磺SaleState ASC,CarID DESC</param>        
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            SqlParameter[] parms = new SqlParameter[]
            {
                SQLHelper.MakeInParam("@TableName", SqlDbType.VarChar, "va_Interface_MC_Master"),
                SQLHelper.MakeInParam("@SqlFilter", SqlDbType.VarChar, sqlFilter),                    
                SQLHelper.MakeInParam("@KeyFieldName", SqlDbType.VarChar, "RID"),                    
                SQLHelper.MakeInParam("@OrderBy", SqlDbType.VarChar, orderBy),
                SQLHelper.MakeInParam("@PageIndex", SqlDbType.Int, currPage),                      
                SQLHelper.MakeInParam("@PageSize", SqlDbType.Int, pageSize)       
            };

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(base.ConnectionString, CommandType.StoredProcedure, PRO_GETLIST, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.GetDataList(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataListCnt
        /// <summary>
        /// õ¼
        /// </summary>
        /// <param name="sqlCondition">ѯ(WHERE)</param>
        /// <returns>int</returns>
        public int GetDataListCnt(string sqlFilter)
        {
            try
            {
                sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
                string tmpSqlFilter = sqlFilter.ToUpper().Trim();
                if (tmpSqlFilter.StartsWith("WHERE"))
                {
                    throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
                }
                if (tmpSqlFilter.StartsWith("AND"))
                {
                    throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
                }

                if (!String.IsNullOrEmpty(sqlFilter))
                {
                    sqlFilter = "WHERE " + sqlFilter;
                }

                string cmdText = SQL_GETLIST_CNT + " " + sqlFilter;
                return (int)SQLHelper.ExecuteScalar(base.ConnectionString, CommandType.Text, cmdText);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCMaster.GetDataListCnt(...):" + ex.Message);
            }
        }
        #endregion

        #region GetParametersGetKeyParameter ȡ
        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name=" entity">ʵ</param>
        /// <returns>SqlParameter</returns>
        SqlParameter[] GetParameters(MCMasterInfo entity)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, entity.RID),
					SQLHelper.MakeInParam("@Shop_Code", SqlDbType.VarChar, entity.Shop_Code),
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, entity.BizNo),
					SQLHelper.MakeInParam("@CardNo", SqlDbType.VarChar, entity.CardNo),
					SQLHelper.MakeInParam("@MemberID", SqlDbType.VarChar, entity.MemberID),
					SQLHelper.MakeInParam("@Name", SqlDbType.VarChar, entity.Name),
					SQLHelper.MakeInParam("@Sex", SqlDbType.VarChar, entity.Sex),
					SQLHelper.MakeInParam("@MobileNo", SqlDbType.VarChar, entity.MobileNo),
					SQLHelper.MakeInParam("@Operate_Date", SqlDbType.DateTime, entity.Operate_Date),
					SQLHelper.MakeInParam("@Operator_Code", SqlDbType.VarChar, entity.Operator_Code),
					SQLHelper.MakeInParam("@Operator_Name", SqlDbType.VarChar, entity.Operator_Name),
					SQLHelper.MakeInParam("@Costs", SqlDbType.Decimal, entity.Costs),
					SQLHelper.MakeInParam("@Charges", SqlDbType.Decimal, entity.Charges),
					SQLHelper.MakeInParam("@Discounts", SqlDbType.Decimal, entity.Discounts),
					SQLHelper.MakeInParam("@PayAmount", SqlDbType.Decimal, entity.PayAmount),
					SQLHelper.MakeInParam("@Remark", SqlDbType.VarChar, entity.Remark),
                    SQLHelper.MakeInParam("@DataFrom", SqlDbType.VarChar, entity.DataFrom)
				};
        }

        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns></returns>
        SqlParameter[] GetKeyParameter(int rID)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, rID)
				};
        }
        #endregion

    } //class end.
} //namespace end.

