/*******************************************************************************
//  Ȩ  (C) 2015 ̿
//    MCPayment.cs
//  ļ˵Ա֧ʽ¼ݲࣻ
//      
//
//  ʶ־ 2016-01-07 10:40:24
//
//  ޸ıʶ
//  ޸˵
*******************************************************************************/

using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;

using VA.Utils;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Config;
using VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.Model;

namespace VA.Modules.JDingMember.Interface.MemberConsume.ClassLibrary.DataAccess
{
    /// <summary>
    /// Ա֧ʽ¼ݲࣻ
    /// </summary>
    public class MCPayment : DAOBase
    {
        const string CODE_PATH = "DAL.MCPayment.";
        SqlParameter[] parms = null;

        static string Tb_Prefix = DBConfig.Tb_Prefix;
        string SQL_INSERT = "INSERT INTO va_Interface_MC_Payments(BizNo,PayType_Code,PayType_Name,PayAmount,Certificate_No)VALUES(@BizNo,@PayType_Code,@PayType_Name,@PayAmount,@Certificate_No)";
        string SQL_DELETE_BY_BIZNO = "DELETE FROM va_Interface_MC_Items WHERE BizNo=@BizNo";
        string SQL_GETLIST = "SELECT * FROM va_Interface_MC_Payments";
        string SQL_GETLIST_CNT = "SELECT COUNT(*) FROM va_Interface_MC_Payments";
        string PRO_GETLIST = "va_Pager201301";

        #region Insert 
        /// <summary>
        /// 룻
        /// </summary>
        /// <param name="entity">Ա֧ʽ¼ʵ</param>
        /// <returns>ɹ򷵻true򣬷false</returns>
        public bool Insert(MCPaymentInfo entity,SqlTransaction trans)
        {
            try
            {
                parms = GetParameters(entity);
                int affectedRows = SQLHelper.ExecuteNonQuery(trans, CommandType.Text, SQL_INSERT, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.Insert(...):" + ex.Message);
            }
        }
        #endregion

        #region DeleteByBizNo ɾ
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns>ɾɹ򷵻true򣬷false</returns>
        public bool DeleteByBizNo(string bizNo)
        {
            try
            {
                SqlParameter[] parms = new SqlParameter[]
				{
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, bizNo)
				};
                int affectedRows = SQLHelper.ExecuteNonQuery(DBConfig.ConnectionString, CommandType.Text, SQL_DELETE_BY_BIZNO, parms);

                return affectedRows > 0 ? true : false;
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.DeleteByBizNo(...):" + ex.Message);
            }
        }
        #endregion              

        #region GetDataList õݼ
        /// <summary>
        /// õݼ
        /// </summary>		
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">ݡ磺"ID DESC"</param>
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            string cmdText = SQL_GETLIST;

            if (!String.IsNullOrEmpty(sqlFilter))
            {
                cmdText += " WHERE 1=1 AND " + sqlFilter;
            }

            if (!String.IsNullOrEmpty(orderBy))
            {
                cmdText += " ORDER BY " + orderBy;
            }

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(DBConfig.ConnectionString, CommandType.Text, cmdText, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataList(...):" + ex.Message);
            }
        }

        /// <summary>
        /// õݼ
        /// </summary>
        /// <param name="currPage">ǰҳ</param>
        /// <param name="pageSize">ÿҳʾļ¼</param>
        /// <param name="sqlFilter">SQLɸѡ磺"NAME LIKE'%%' AND SEX='1'"</param>
        /// <param name="orderBy">磺SaleState ASC,CarID DESC</param>        
        /// <returns>ݼDataTable</returns>
        public DataTable GetDataList(int currPage, int pageSize, string sqlFilter, string orderBy)
        {
            sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
            string tmpSqlFilter = sqlFilter.ToUpper().Trim();
            if (tmpSqlFilter.StartsWith("WHERE"))
            {
                throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
            }
            if (tmpSqlFilter.StartsWith("AND"))
            {
                throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
            }

            SqlParameter[] parms = new SqlParameter[]
            {
                SQLHelper.MakeInParam("@TableName", SqlDbType.VarChar, "va_Interface_MC_Payments"),
                SQLHelper.MakeInParam("@SqlFilter", SqlDbType.VarChar, sqlFilter),                    
                SQLHelper.MakeInParam("@KeyFieldName", SqlDbType.VarChar, "RID"),                    
                SQLHelper.MakeInParam("@OrderBy", SqlDbType.VarChar, orderBy),
                SQLHelper.MakeInParam("@PageIndex", SqlDbType.Int, currPage),                      
                SQLHelper.MakeInParam("@PageSize", SqlDbType.Int, pageSize)       
            };

            try
            {
                DataSet ds = SQLHelper.ExecuteDataset(base.ConnectionString, CommandType.StoredProcedure, PRO_GETLIST, parms);
                return ds.Tables[0];
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataList(...):" + ex.Message);
            }
        }
        #endregion

        #region GetDataListCnt
        /// <summary>
        /// õ¼
        /// </summary>
        /// <param name="sqlCondition">ѯ(WHERE)</param>
        /// <returns>int</returns>
        public int GetDataListCnt(string sqlFilter)
        {
            try
            {
                sqlFilter = sqlFilter == null ? String.Empty : sqlFilter;
                string tmpSqlFilter = sqlFilter.ToUpper().Trim();
                if (tmpSqlFilter.StartsWith("WHERE"))
                {
                    throw new Exception("[sqlFilter]ֵ\"where\"ͷ");
                }
                if (tmpSqlFilter.StartsWith("AND"))
                {
                    throw new Exception("[sqlFilter]ֵ\"and\"ͷ");
                }

                if (!String.IsNullOrEmpty(sqlFilter))
                {
                    sqlFilter = "WHERE " + sqlFilter;
                }

                string cmdText = SQL_GETLIST_CNT + " " + sqlFilter;
                return (int)SQLHelper.ExecuteScalar(base.ConnectionString, CommandType.Text, cmdText);
            }
            catch (Exception ex)
            {
                throw new Exception(CODE_PATH + "MCPayment.GetDataListCnt(...):" + ex.Message);
            }
        }
        #endregion

        #region GetParametersGetKeyParameter ȡ
        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name=" entity">ʵ</param>
        /// <returns>SqlParameter</returns>
        SqlParameter[] GetParameters(MCPaymentInfo entity)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, entity.RID),
					SQLHelper.MakeInParam("@BizNo", SqlDbType.VarChar, entity.BizNo),
					SQLHelper.MakeInParam("@PayType_Code", SqlDbType.VarChar, entity.PayType_Code),
					SQLHelper.MakeInParam("@PayType_Name", SqlDbType.VarChar, entity.PayType_Name),
					SQLHelper.MakeInParam("@PayAmount", SqlDbType.Decimal, entity.PayAmount),
					SQLHelper.MakeInParam("@Certificate_No", SqlDbType.VarChar, entity.Certificate_No)
				};
        }

        /// <summary>
        /// ȡ飻
        /// </summary>
        /// <param name="rID">¼ID</param>
        /// <returns></returns>
        SqlParameter[] GetKeyParameter(int rID)
        {
            return new SqlParameter[]
				{
					SQLHelper.MakeInParam("@RID", SqlDbType.Int, rID)
				};
        }
        #endregion

    } //class end.
} //namespace end.

