﻿/*!
* smartListTable v1.0 
*
* Author: czh 
* 
* Date: 2015.06
*/

var hScrollBarHeight = 18; //水平滚动条的高度；
var vScrollBarWidth = 18; //垂直滚动条的宽度；
var smartListTable_isOverflow = false; //表格内容是否溢出，也就是表格的宽度是否大于当前浏览器窗口的宽度；
var isIE = false;
var isIE6 = false;
var isIE7 = false;
var isIE8 = false;
var isIE9 = false;

var JTongSmartListTable_trClick = null;
var JTongSmartListTable_trDblclick = null;
var JTongSmartListTable_afterSelect = null;
var JTongSmartListTable_afterCancelSelect = null;

if (navigator.userAgent.indexOf("MSIE") > 0) {
    isIE = true;

    if (navigator.userAgent.indexOf("MSIE 9.0") > 0) {
        isIE9 = true;
    }
    else if (navigator.userAgent.indexOf("MSIE 8.0") > 0) {
        isIE8 = true;
    }
    else if (navigator.userAgent.indexOf("MSIE 7.0") > 0) {
        isIE7 = true;
    }
    else if (navigator.userAgent.indexOf("MSIE 6.0") > 0) {
        isIE6 = true;
    }
}


//初始化smartListTable
function JTongSmartListTable_init() {
    
    var smartListTables = $(".jtongui-smartlisttable").find(".tableheader");
    var smartListTableBodies = $(".jtongui-smartlisttable").find(".tablebody");
    
    //对齐表格（表头与表体）
    smartListTable_alignTable(smartListTables, smartListTableBodies);

    //绑定事件;
    smartListTables.each(function () {
        var smartListTableID = $(this).attr("id");
        var ckb_selectAll = $(this).find(":checkbox");
        ckb_selectAll.click(function () {
            smartListTable_selectAll(smartListTableID, this.checked);
        });
    });

    smartListTableBodies.each(function () {
        var tbHeader = $("#" + $(this).attr("tbHeader"));
        $(":checkbox").click(function (event) {
            if (this.checked == false) {
                tbHeader.find(":checkbox")[0].checked = false;
            }
            var trObj = $(this).parent().parent();
            smartListTable_selectTR(this.checked, trObj);
            event.stopPropagation();
        });
    });

    
    //绑定行事件及样式；
    smartListTableBodies.each(function () {
        $(this).find("tr").each(function () {
            $(this).mouseover(function () {
                $(this).addClass("row_mouseover");
            }).mouseout(function () {
                $(this).removeClass("row_mouseover");
            }).click(function () {
                var checkboxObj = $(this).find(":checkbox")[0];
                if (checkboxObj != undefined) {
                    var checked = checkboxObj.checked;
                    if (checked == false) {
                        checkboxObj.checked = true;
                    }
                    else {
                        checkboxObj.checked = false;
                    }
                    smartListTable_selectTR(checkboxObj.checked, $(this));
                }

                try
                {
                    if (JTongSmartListTable_trClick != null) {
                        JTongSmartListTable_trClick($(this)[0]);
                    }
                }catch(e){}

            }).dblclick(function(){
                try {
                    if (JTongSmartListTable_trDblclick != null) {
                        JTongSmartListTable_trDblclick($(this)[0]);
                    }
                } catch (e) { }
            });

        });
    }); 
}

function JTongSmartListTable_resize() {
    
    var smartListTables = $(".jtongui-smartlisttable").find(".tableheader");
    var smartListTableBodies = $(".jtongui-smartlisttable").find(".tablebody");

    smartListTable_alignTable(smartListTables, smartListTableBodies);
}

function smartListTable_alignTable(smartListTables, smartListTableBodies) {

    var tdTotalWidth = 0;
    var colCount = 0; //表格列数量；

    //计算表格总宽度;
    smartListTableBodies.each(function () {
        var tbHeader = $("#" + $(this).attr("tbHeader"));
        var tds = $(this).find("tr:eq(0) td");
        colCount = tds.length;
        tds.each(function () {
            var colIndex = $(this).index();

            //经czh测试发现，该方法计算出来的是单元格的实际宽度，而不是在样式表中设置的css宽度；
            //var width = tbHeader.find("tr:eq(0) td").eq(colIndex).css("width");  
            var width = tbHeader.find("tr:eq(0) td").eq(colIndex)[0].style.width;
            var widthFinal = parseInt(width.toString().toLowerCase().replace("px", ""));

            if (isNaN(widthFinal)) {
                widthFinal = 20;
            }

            tdTotalWidth += widthFinal;
        });
    });

    //表格的真实宽度(通过tdTotalWidth计算出来的宽度并没有包含单元格边框及cellpadding所占的宽度)；
    //如果如果将totalWidth设置为表格宽度的话，则会自动减少最后一列的宽度来进行补充，如果最后一列的
    //宽度不足，则将导致表头和表体对不齐，所以，这里要计算一出表格的真实宽度；
    var table_totalRealWidth = 0;
    var table_tdWidth = tdTotalWidth;
    var table_cellpaddingWidth = colCount * 6; //cellpading所占的总宽度;cellpadding为3，左右两侧相加的值为6；
    var table_borderWidth = colCount + 1;  //表格边框所占额总宽度；
    totalRealWidth = table_tdWidth + table_cellpaddingWidth + table_borderWidth;

    //调试代码；
    //alert("totalRealWidth:"+ totalRealWidth +",table_tdWidth:" + table_tdWidth + ",table_cellpaddingWidth:" + table_cellpaddingWidth + ",table_borderWidth:" + table_borderWidth);

    //当浏览器窗口宽度<表格各列宽度之和时，表头和表体将出现对不起的现象；
    //解决办法：当浏览器窗口宽度<表格各列宽度之和时，将表格的宽度由100%更改为表格各列宽度之和；
    var windowWidth = $(window).outerWidth();
    if (totalRealWidth > windowWidth) {
        smartListTables.css("width", totalRealWidth);
        $(".bodyContainer").css("width", totalRealWidth - 2); //由于smartListTable-bodyContainer的边框为1px，两侧总边框为2px，所以smartListTable-bodyContainer得宽度应该减去2；

        //调试代码
        //alert(totalRealWidth + "|" + smartListTables.outerWidth());

        $(".jtongui-smartlisttable").css("overflow", "scroll");
        $(".jtongui-smartlisttable").css("overflow-y", "hidden");
        smartListTable_isOverflow = true;
    }
    else {
        smartListTables.css("width", "100%");
        $(".bodyContainer").css("width", "");

        $(".jtongui-smartlisttable").css("overflow", "");
        smartListTable_isOverflow = false;
    }

    //列对齐
    smartListTableBodies.each(function () {
        var tbHeader = $("#" + $(this).attr("tbHeader"));

        var tbHeaderWidth = tbHeader.outerWidth();
        var tbBodyWidth = tbHeaderWidth;
        if (isIE6) {
            tbBodyWidth = tbHeaderWidth - vScrollBarWidth;
            smartListTableBodies.width(tbBodyWidth);
        }

        var tds = $(this).find("tr:eq(0) td");
        tds.each(function () {
            var colIndex = $(this).index();

            //经czh测试发现，该方法计算出来的是单元格的实际宽度，而不是在样式表中设置的css宽度；
            //var width = tbHeader.find("tr:eq(0) td").eq(colIndex).css("width");            
            var width = tbHeader.find("tr:eq(0) td").eq(colIndex)[0].style.width;

            //调试代码：
            //var width0 = tbHeader.find("tr:eq(0) td").eq(colIndex).outerWidth();
            //alert( colIndex + "|" + width + "|" + width0);
            
            var widthFinal = parseInt(width.toString().toLowerCase().replace("px", ""));
            if (isNaN(widthFinal)) {
                widthFinal = 20;
            }

            if (colIndex != tds.size() - 1) {
                $(this).css("width", widthFinal);
                //alert(widthFinal);
            }
        });
    });
}

function tbGridList_createVScroolBar() {

    //自动构建自定义垂直滚动条；
    var $control = $(".jtongui-smartlisttable");
    var $bodyContainer = $control.find(".bodyContainer");

    var bodyContainerHeight = $bodyContainer.outerHeight();
    var bodyContainerScrollHeight = $bodyContainer[0].scrollHeight;

    //方案1
    //var dataContentHeight = $control.find(".tablebody")[0].scrollHeight; //数据表格的实际高度；

    //方案2
    var dataContentHeight = bodyContainerScrollHeight;

    if (bodyContainerScrollHeight > bodyContainerHeight) {
        //if (dataContentHeight > bodyContainerHeight) {

        $control.append("<div class=\"vScrollbar\"><div class=\"vScrollbarContent\"></div></div>");

        var $scrollBar = $control.find("div.vScrollbar");
        var $scrollBarContent = $scrollBar.find(".vScrollbarContent");

        var scrollBarHeight = bodyContainerHeight;
        var scrollBarTop = $bodyContainer.offset().top;
        var scrollBarContentHeight = dataContentHeight;

        $scrollBar.height(scrollBarHeight);
        $scrollBar.css("top", scrollBarTop);
        $scrollBarContent.height(scrollBarContentHeight);

        $scrollBar.bind("scroll", function () {

            /**垂直滚动条*/
            var scrollTop = 0;
            scrollTop = $(this).scrollTop();
            $bodyContainer.scrollTop(scrollTop);
        });

        $bodyContainer.bind("scroll", function () {

            /**垂直滚动条*/
            var scrollTop = 0;
            scrollTop = $(this).scrollTop();
            $scrollBar.scrollTop(scrollTop);
        });
    }
}

function smartListTable_selectAll(smartListTableID, checked) {
    $("table[tbHeader=" + smartListTableID + "]").each(function () {
        $(this).find(":checkbox").each(function () {
            this.checked = checked;

            var $trObj = $(this).parent().parent();
            smartListTable_selectTR(checked, $trObj);
        });
    });
}
function smartListTable_selectTR(checkboxState, $trObj) {
    if (checkboxState) {
        $trObj.addClass("row_selected");
        
        if (JTongSmartListTable_afterSelect != null) {
            JTongSmartListTable_afterSelect($trObj[0]);
        }
    }
    else {
        $trObj.removeClass("row_selected");

        if (JTongSmartListTable_afterCancelSelect != null) {
            JTongSmartListTable_afterCancelSelect($trObj[0]);
        }
    }
}


$(function () {
    $(window).resize(function () {
        JTongSmartListTable_resize();
    });
});     

