﻿function JTongAccordion_init() {

    $(".jtongui-accordion").each(function () {
        var $controlContainer = $(this).parent();
        var $controlObj = $(this);
        $controlObj.height($controlContainer.height());
        JTongAccordion_setBodyHeight($controlObj);

        //如果一个页面上包含了多个Accordion控件，并且默认只有第1个Accordion控件显示(如：将2个Accordion控件分别放到tab控件的两个选显卡中)，那么调用JTongAccordion_init
        //方法将只会对第1个Accordion生效。解决办法：每当Accordion控件显示的时候，就调用一次JTongAccordion_init()方法，
        //但这样做即将导致 .submenu .head 的click的事件被绑定多次。所以，这里要先执行一次unbind方法，然后在绑定click事件。
        $(this).find(".submenu .head").unbind("click");
        $(this).find(".submenu .head").bind("click", function (event) {
            $controlObj.find(".submenu").removeClass("selected");
            $(this).parent().addClass("selected");
            JTongAccordion_setBodyHeight($controlObj);        
        });

    });
}

function JTongAccordion_setBodyHeight($controlObj) {

    var controlHeight = 0;
    var height_used = 0;
    var height_remain = 0;
    var headHeight = 0;

    controlHeight = $controlObj.height();

    $controlObj.find(".submenu .head").each(function () {
        headHeight = $(this).outerHeight(true); //加上1像素的边框          
        height_used += headHeight;
    });

    //设置当前选中的.body“的高度为：总高度 - 所有菜单项头部的高度。
    height_remain = controlHeight - height_used - 1;

    //alert(height_remain);
    $controlObj.find(".selected .body").height(height_remain);
}